unit Unit1;

{ tectonic
  helper program

  version 1.0
  april 2018
}  

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, ExtCtrls, shellApi;

type
  TForm1 = class(TForm)
    PaintBox1: TPaintBox;
    loadBtn: TBitBtn;
    storeBtn: TBitBtn;
    gridBtn: TSpeedButton;
    playBtn: TSpeedButton;
    StaticText1: TStaticText;
    Label1: TLabel;
    StaticText2: TStaticText;
    Label2: TLabel;
    hplusBtn: TSpeedButton;
    hminBtn: TSpeedButton;
    vplusBtn: TSpeedButton;
    vminBtn: TSpeedButton;
    msglabel: TLabel;
    CheckBox1: TCheckBox;
    clearBtn: TBitBtn;
    hintBtn: TBitBtn;
    helpBtn: TBitBtn;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    warningbox: TCheckBox;
    digitBtn: TSpeedButton;
    Timer1: TTimer;
    optresetBtn: TBitBtn;
    procedure gridBtnClick(Sender: TObject);
    procedure PaintBox1Paint(Sender: TObject);
    procedure PaintBox1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure PaintBox1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure PaintBox1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure loadBtnClick(Sender: TObject);
    procedure storeBtnClick(Sender: TObject);
    procedure helpBtnClick(Sender: TObject);
    procedure clearBtnClick(Sender: TObject);
    procedure hintBtnClick(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure playBtnClick(Sender: TObject);
    procedure digitBtnClick(Sender: TObject);
    procedure warningboxClick(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure hplusBtnMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure hplusBtnMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure optresetBtnClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

  TGameStatus = (gsGrid,gsDigit,gsPlay,gsEnd);

procedure setGameStatus(gs : TGameStatus);

var Form1: TForm1;
    gameStatus : TGameStatus;

implementation

{$R *.dfm}

uses game_unit,io_unit;

type TPaintMode = (pmNone,pmPaint,pmErase);
     TGameMessage = (gmGridBtn,gmDigitBtn,gmPlayBtn,gmClearBtn,gmDelete,
     gmEnd);

const fieldsize = 48;      //square field size in pixels
      markcolor = $ff00ff;
      formMessage = 'tectonic-helper';
      gridmessage = 'draw grid, press DIGIT';
      digitmessage = 'enter digits(?), press PLAY';
      playmessage = 'find solution..';
      endmessage = 'Game solved. Congratulations !';
      hop : array[1..5] of byte = (5,32,20, 5,32);  //coordinate of options
      vop : array[1..5] of byte = (5, 5,16,28,28);
      Oprect : array[1..5] of Trect = ((left: 4; top: 5; right:15; bottom:21),
                                       (left:31; top: 5; right:42; bottom:21),
                                       (left:19; top:16; right:30; bottom:32),
                                       (left: 4; top:28; right:15; bottom:44),
                                       (left:31; top:28; right:43; bottom:44));

var errorMark : boolean;//errorfields are marked
    marker : byte = 0;
    paintMode : TPaintMode;
    timercode : byte;
    hintActive : byte; //  <> 0 if hint
    h1 : THint1;
    h2 : THint2;
    h3 : THint3;
    h4 : THint3;
    oldOpt : byte;
    oldField : byte;  // <> 0 if selection
    hintcount : byte;

procedure clearMarker;forward;
procedure setMarker(n : byte);forward;

//field <---> (x,y)  conversion

function XY2fieldNr(x,y : smallInt) : byte;
var xmf,ymf,xdf,ydf : byte;
begin
 result := 0;
 xmf := x mod fieldsize;
 ymf := y mod fieldsize;
 xdf := x div fieldsize;
 ydf := y div fieldsize;
 if (xmf > 5) and (ymf > 5) and (xmf < 43) and (ymf < 43) then
  result := 1 + xdf + HSize*ydf;
end;

procedure fieldNr2XY(var x,y : smallInt; n : byte);
var row, col : byte;
begin
 col := (n-1) mod HSize;
 row := (n-1) div HSize;
 x := col * fieldsize;
 y := row * fieldsize;
end;

procedure XY2OptionField(x,y : smallInt;var fld,opt : byte);
//find field and option nr for (x,y)
//if valid opt:  fld <> 0
var i,f : byte;
    r : Trect;
    hit : boolean;
    x1,y1 : smallInt;
begin
 hit := false;
 opt := 0;
 fld := 0;
 i := 0;
 f := XY2FieldNr(x,y);
 if f > 0 then
  begin
   fieldNr2XY(x1,y1,f);
   repeat
    inc(i);
    with field[f] do if (nr = 0) and (options and (1 shl i) <> 0) then
     begin
      r := OpRect[i];
      r.Left := r.Left + x1;
      r.Right := r.Right + x1;
      r.Top := r.Top + y1;
      r.Bottom := r.Bottom + y1;
      hit := (x > r.Left) and (x < r.Right) and (y > r.Top) and (y < r.Bottom);
     end;
   until hit or (i = 5);
   if hit then begin
                fld := f;
                opt := i;
               end;
  end;
end;

//-- low level helpers

procedure EnableDimensionButtons(b : boolean);
begin
 with form1 do
  begin
   HPlusBtn.enabled := b;
   HMinBtn.enabled := b;
   VPlusBtn.enabled := b;
   VminBtn.enabled := b;
  end;
end;

procedure postmessage(s : string);
begin
 form1.msglabel.Caption := s;
end;

procedure showdimensions;
begin
 with form1 do
  begin
   statictext1.caption := inttostr(HSize);
   statictext2.caption := inttostr(VSize);
  end; 
end;

//--painting-----

procedure paintMarker(f : byte; switch : boolean);
//use markcolor if switch=true else white
var i : byte;
    x,y,x1,y1,x2,y2 : smallInt;
begin
 fieldNr2XY(x,y,f);
 x1 := x + 2;
 y1 := y + 2;
 x2 := x1 + fieldsize - 4;
 y2 := y1 + fieldsize - 4;
 with form1.PaintBox1.Canvas do
  begin
   pen.Width := 1;
   if switch then pen.color := markColor else pen.color := $ffffff;
   for i := 0 to 2 do
    begin
     moveto(x1+i,y1+i);
     lineto(x1+i,y2-i);
     lineto(x2-i,y2-i);
     lineto(x2-i,y1+i);
     lineto(x1+i,y1+i);
    end;
  end;
end;

procedure paintEmptyField(f : byte);
var x,y : smallInt;
    r : Trect;
begin
 fieldNr2XY(x,y,f);
 r.Left := x + 2;
 r.Top := y + 2;
 r.Right := x + fieldSize - 1;
 r.Bottom := y + fieldSize - 1;
 with form1.PaintBox1.Canvas do
  begin
   brush.color := $ffffff;
   brush.Style := bsSolid;
   fillrect(r);
  end;
 if f = marker then paintmarker(f,true);
end;

procedure paintFieldEdges(f : byte);
var x,y,x1,y1,x2,y2 : smallInt;
begin
 fieldNr2XY(x,y,f);
 with form1.paintbox1.Canvas do
  begin
   pen.Width := 1;
   x1 := x + 1;
   y1 := y + 1;
   x2 := x + fieldSize-1;
   y2 := y + fieldSize-1;
   pen.color := $ffffff;   //erase edges
   moveto(x1,y1);
   lineto(x1,y2);
   lineto(x2,y2);
   lineto(x2,y1);
   lineto(x1,y1);
   pen.color := $000000;  //paint edge if grid bit is set
   with field[f] do
    begin
     if (grid and 1) <> 0 then begin
                                moveto(x1,y1); lineto(x1,y2+1);
                               end;
     if (grid and 2) <> 0 then begin
                                moveto(x1,y1); lineto(x2+1,y1);
                               end;
     if (grid and 4) <> 0 then begin
                                moveto(x2,y1); lineto(x2,y2+1);
                               end;
     if (grid and 8) <> 0 then begin
                                moveto(x1,y2); lineto(x2+1,y2);
                               end;
    end;//with
  end;//with
end;

procedure paintgameGrid;
//paint the grid
var i : byte;
begin
 with form1.PaintBox1 do with Canvas do
  begin
   brush.Color := $ffffff;
   brush.style := bsSolid;
   fillrect(rect(0,0,width,height));
   pen.Width := 1;
   pen.Color := $000000;
   for i := 0 to HSize do
    begin
     moveto(i*fieldsize,0);
     lineto(i*fieldsize,height);
    end;
   for i := 0 to VSize do
    begin
     moveto(0,i*fieldsize);
     lineto(width,i*fieldSize);
    end;
  end;
end;

procedure paintfieldNr(f : byte);
var x,y : smallInt;
    ch : char;
begin
 fieldNr2XY(x,y,f);
 with form1.PaintBox1.Canvas do
  begin
   font.name := 'arial';
   font.Style := [];
   font.Height := 32;
   brush.style := bsClear;
   with field[f] do
    begin
     case nrType of
      ntOrg  : font.color := $000080;
      ntPlay : font.color := $000000;
      ntNone : font.color := $ffffff;
     end;
     ch := chr(ord('0')+ field[f].nr);
     textout(x+16,y+8,ch);//ch
    end;
  end;
 if marker = f then paintmarker(f,true);
end;

procedure paintfieldOptions(f : byte);
var x,y : smallInt;
    i   : byte;
    ch  : char;
begin
 fieldNr2XY(x,y,f);
 with form1.paintbox1.Canvas do
  begin
   font.Name := 'arial';
   font.Height := 16;
   font.color := $808080;
   brush.Style := bsClear;
   for i := 1 to 5 do
    begin
     if (field[f].options and (1 shl i)) <> 0 then
      begin
       ch := chr(ord('0')+i);
       textout(x+hop[i],y+vop[i],ch);
      end;
    end;
  end;
 if f = marker then paintmarker(f,true);
end;

procedure paintErrorField(f : byte);
//set field error marker
//set general errormark
var x,y : smallInt;
    d : byte;
begin
 fieldNr2XY(x,y,f);
 inc(x,5);
 inc(y,5);
 d := fieldsize - 10;
 with form1.PaintBox1.Canvas do
  begin
   pen.width := 1;
   pen.Color := $0000ff;
   ellipse(x,y,x+d,y+d);
  end;
 field[f].marked := true;
 errormark := true;
end;

procedure paintErrorGroup(grp : byte);
var i : byte;
begin
 for i := 1 to HSize*VSize do
  with field[i] do
   if groupNr = grp then painterrorfield(i);
end;

procedure paintField(f : byte);
begin
 paintEmptyField(f);
 if field[f].nr <> 0 then paintfieldNr(f)
  else
   if (form1.checkbox1.Checked and (gameStatus <> gsGrid)) then
       paintfieldOptions(f);
 if field[f].marked then paintErrorField(f);
end;

procedure repaintFields;
var i : byte;
begin
 for i := 1 to HSize*VSize do paintfield(i);
end;

procedure paintEdgeData(f,m : byte);
//set,clear edge bits m of field f
//check paintmode
//helper of setEdge procedure
var amask : byte;
begin
 if paintmode = pmErase then
  begin
   amask := m xor $f;
   m := 0;
  end
  else amask := $f;
 field[f].grid := (field[f].grid and amask) or m;
 paintFieldEdges(f);
end;

procedure paintformEdges(col : TColor);
//1 pixel wide edge around paintbox1
var x1,y1,x2,y2 : word;
begin
 with form1.paintbox1 do
  begin
   x1 := left - 1;
   y1 := top - 1;
   x2 := left + width;
   y2 := top + height;
  end;
 with form1.canvas do
  begin
   pen.Color := col;
   pen.Width := 1;
   moveto(x2,y1);
   lineto(x1,y1);
   lineto(x1,y2);
   lineto(x2,y2);
   lineto(x2,y1);
  end;
end;

procedure paintoptionmarks(h : THint3);
//paint hint type 3 options
//green: selecting
//red  : to be removed
var i,fld,msk : byte;
    x,y,x1,y1 : smallInt;
    r : Trect;
begin
 with form1.PaintBox1.Canvas do
  begin
   pen.Width := 1;
   brush.Style := bsClear;
   for fld := 1 to 6 do    
    with h[fld] do
     if h[fld].nr <> 0 then
      begin
       fieldNr2XY(x,y,nr);
       for i := 1 to 5 do
        begin
         msk := 1 shl i;
         x1 := x + hop[i]-1;
         y1 := y + vop[i];
         r := rect(x1,y1,x1+10,y1+16);
         if (msk and green) <> 0 then
          begin
           pen.Color := $00e000;
           rectangle(r);
          end;
         if (msk and red) <> 0 then
          begin
           pen.color := $0000ff;
           rectangle(r);
          end;
        end;//for i
      end;//with h[i]
  end;//with form1..
end;

//low level control

procedure clearMarker;
begin
 if marker <> 0 then
  begin
   paintmarker(marker,false);
   marker := 0;
  end;
end;

procedure setmarker(n : byte);
begin
 clearmarker;
 if n <> 0 then
  begin
   paintmarker(n,true);
   marker := n;
  end;
end;

procedure advanceMarker;
var n : byte;
begin
 n := marker + 1;
 if n > HSize*VSize then N := 1;
 setMarker(n);
end;

procedure initGridEdges;
// grid bits:   0:left 1: top 2: 3: bottom
var i,hv,lb,f : byte;
begin
 hv := HSize*Vsize;
 lb := hv - Hsize;
 for i := 1 to hv do field[i].grid := 0;
 for i := 1 to HSize do
  begin
   field[i].grid := 2;
   field[i+lb].grid := 8;
  end;
 for i := 1 to Vsize do
  begin
   f := (i-1)*Hsize+1;
   field[f].grid := field[f].grid or 1;
   f := f + Hsize-1;
   field[f].grid := field[f].grid or 4;
  end;
end;  

procedure clearErrorFields;
//removes eror marks from fields
//resets errormark
var i : byte;
begin
 for i := 1 to HSize*VSize do
  with field[i] do
   if marked then begin
                   marked := false;
                   paintfield(i);
                  end;
 errormark := false;
end;

procedure setPaintbox1Dimensions;
//set width , height
begin
 with form1 do
  begin
   paintFormEdges(canvas.brush.Color);  //erase old edges
   with PaintBox1 do
    begin
     width := HSize * fieldsize + 1;
     height := VSize * fieldsize + 1;
     left:= 8 + (15*fieldsize - width) div 2;
     top := 120 + (10*fieldsize - height) div 2;
    end;
   paintbox1.Invalidate;
   paintFormEdges(clBlack);
  end;//with form1
end;

procedure setEdge(x,y : smallInt);
//check (x,y)
//set & paint grid edge
var c,r,xm,ym,f  : byte;
    hit   : boolean;
begin
 with form1.paintbox1 do                       //exclude edges of game
  if (x < 10) or (y < 10) or (x >= width-12) or (y >= height-12) then exit;
//
 hit := false;
 c := x div fieldsize;
 r := y div fieldsize;
 xm := x mod FieldSize;
 ym := y mod FieldSize;
 f := 1 + c + r*Hsize;
//--vertical left
 if (xm < 8) and (ym > 12) and (ym < 36) then
  begin
   hit := true;
   paintEdgeData(f,1);
   paintEdgeData(f-1,4);
  end;
//--vertical right
 if (hit = false) then
  if (xm > 40) and (ym > 12) and (ym < 32) then
   begin
    hit:= true;
    paintEdgeData(f,4);
    paintEdgeData(f+1,1);
   end;
//--horizontal up
 if (hit = false) then
  if (ym < 8) and (xm > 12) and (xm < 36) then
   begin
    hit := true;
    paintEdgeData(f,2);
    paintEdgeData(f-Hsize,8);
   end;
//--horizontal down
 if (hit = false) then
  if (ym > 40) and (xm > 12) and (xm < 36) then
   begin
    paintEdgeData(f,8);
    paintEdgeData(f+Hsize,2);
   end;
end;

//-- central game control helpers

function builtGroups : boolean;
//initiate groups
//return true if OK, else post message
var m : byte;
begin
 result := false;
 if errorMark then
  begin
   repaintfields;
   errorMark := false;
  end;
 m := initGroups;
 case m shr 6 of
  0 : begin
       result := true;
       initOptions;
       repaintFields;
      end;
  1 : postmessage('error: too many groups');
  2 : begin
       postmessage('error: group > 5');
       painterrorgroup(m and $3f);
      end;
 end;//case
end;

function checkOptions : boolean;
//return true if
//- no empty option fields
//- no options missing in fields
var gameCheck : word;
    fld,grp,m,n : byte;
begin
 gamecheck := testGameOK;
 if gamecheck = 0 then begin
                        result := true;
                        exit;
                       end;
//
 result := false;
 if (gameCheck and $4000) <> 0 then
  begin
   fld := gameCheck and $ff;
   postmessage('no options in field ');
   painterrorfield(fld);
  end;
 if (gamecheck and $8000) <> 0 then
  begin
   grp := gameCheck and $ff;
   m := (gameCheck and $3f00) shr 8;
   n := getBit1(m);
   postmessage('option '+inttostr(n)+' missing in group ');
   painterrorgroup(grp);
  end;//if
end;

procedure clearGameDigits(nt : TNrType);
var i : byte;
begin
 for i := 1 to HSize*VSize do
  with field[i] do
   begin
    if nr = 0 then options := optionmask[groupSize[groupnr]];
    if nrType = nt then begin
                         nr := 0;
                         nrType := ntNone;
                         marked := false;
                         options := optionmask[groupSize[groupnr]];
                        end;
   end;
end;

procedure ClearGame;
var i : byte;
begin
 for i :=1 to HSize*VSize do
  with field[i] do
   begin
    nr := 0;
    nrType := ntNone;
    groupNr := 0;
    marked := false;
    options := 0;
   end;
end;  

//--- main control ---

procedure setGameStatus(gs : TGameStatus);
var s : string;
begin
 gameStatus := gs;
 with form1 do
  case gs of
   gsGrid   : begin
               clearMarker;
               form1.Caption := formMessage;
               msglabel.caption := gridmessage;
               gridBtn.Down := true;
               EnableDimensionbuttons(true);
              end;
   gsDigit  : begin
               setmarker(1);
               form1.Caption := formMessage;
               msglabel.caption := digitmessage;
               digitBtn.down := true;
               enableDimensionbuttons(false);
              end;
   gsPlay   : begin
               msglabel.caption := playmessage;
               playBtn.Down := true;
               enableDimensionbuttons(false);
               hintcount := 0;
              end;
   gsEnd    : begin
               s := endmessage;
               if hintcount > 0 then
                s := s + ' ('+ inttostr(hintcount) + ' hints)';
               msglabel.caption := s;
              end;
  end;//case
end;


procedure GameControl(gm : TGameMessage);
//button messages arrive here
begin
 case gm of
  gmGridBtn  : begin
                clearGame;
                repaintFields;
                setGameStatus(gsGrid);
               end;
  gmDigitBtn : case gamestatus of
                gsGrid  : begin
                           if errormark then ClearErrorfields;
                           if builtGroups then
                            begin
                             setGameStatus(gsDigit);
                             if form1.CheckBox1.Checked then repaintfields;
                            end
                            else form1.gridBtn.Down := true;
                          end;
                gsPlay,
                gsEnd   : begin
                           clearGameDigits(ntPlay);
                           recalcfieldoptions;
                           setGameStatus(gsDigit);
                           repaintfields;
                          end;
               end;//case
  gmPlayBtn  : case gamestatus of
                gsGrid : if builtGroups then setGameStatus(gsDigit)
                          else form1.gridBtn.Down := true;
                gsDigit : if checkOptions then setgameStatus(gsPlay)
                           else form1.digitBtn.Down := true;
               end;
  gmClearBtn : begin
                if errormark then begin
                                   clearErrorFields;
                                   setGameStatus(gameStatus);
                                   exit;
                                  end;//restore message
                case gamestatus of
                 gsGrid   : begin
                             initgridedges;
                             form1.paintbox1.invalidate;
                             errormark := false;
                             postmessage('');
                            end;
                 gsDigit  : begin
                             clearGameDigits(ntOrg);
                             clearGameDigits(ntPlay);
                             recalcFieldoptions;
                             repaintfields;
                            end;
                 gsPlay,
                 gsEnd    : begin
                             clearGameDigits(ntPlay);
                             recalcFieldoptions;
                             repaintfields;
                             setgameStatus(gsPlay);
                            end;
                end;//case
               end;
  gmEnd      : setGameStatus(gsEnd);
 end;//case
end;

procedure processDelete;
//delete key pressed
begin
 if marker = 0 then exit;
//
 if errormark then clearErrorfields;
 case gamestatus of
   gsGrid,
   gsDigit  : begin
               clearDigit(marker);
               repaintfields;
              end;
   gsPlay   : if field[marker].nrType = ntPlay then
               begin
                clearDigit(marker);
                repaintfields;
               end;
 end;//case
end;

procedure addPlayNumber(fld,nr : byte);
//common code to enter digit in gsPlay mode
begin
 enterdigit(fld,nr,ntPlay);
 repaintfields;
 if checkEnd then gameControl(gmEnd)
  else if form1.warningbox.Checked then checkOptions;
end;

procedure addOrgNumber(fld,nr : byte);
//common code to  enter org game digit
begin
 enterdigit(fld,nr,ntOrg);
 checkoptions;
 repaintfields;
end;

procedure procActiveHints;
var i,fld : byte;
begin
 if HintActive = 1 then
  begin
   addPlayNumber(h1.fld,h1.nr);
   hintActive := 0;
  end;
//
 if hintActive = 2 then
  begin
   addplayNumber(h2.fld,h2.nr);
   hintActive := 0;
  end;
//
 if hintactive = 3 then
 begin
  fld := h3[1].nr;
  with field[fld] do
   begin
    options := options and (h3[1].red xor $3e);
    paintfield(fld);
   end;
  for i := 2 to 6 do
   with h3[i] do if green <> 0 then paintfield(nr);
  hintactive := 0;
 end;
//
 if hintActive = 4 then
  begin
   for i := 1 to 5 do
    begin
     fld := h4[i].nr;
     if fld <> 0 then
      begin
       with field[fld] do options := options and (h4[i].red xor $3e);
       paintfield(fld);
      end;
    end;//for
   hintActive := 0;
  end;
end;

// mouse events

procedure TForm1.PaintBox1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var col,row,xmod,ymod : byte;
    center : boolean;
begin
 hintActive := 0;
 with form1.PaintBox1 do
  if (x < 10) or (x > width - 10) or (y < 10) or (y > height - 10) then exit;
//
 col := x div Fieldsize;
 row := y div fieldsize;
 xmod := x mod fieldsize;
 ymod := y mod fieldsize;
 center := (xmod > 15) and (xmod < fieldsize-15) and
           (ymod > 15) and (ymod < fieldsize-15);
//
 case button of
  mbLeft : case gameStatus of
            gsGrid  : paintMode:=pmPaint;
            gsDigit : if oldfield = 0 then
                       begin
                        if center then setmarker(1+col+row*HSize);
                       end
                       else addOrgNumber(oldfield,oldOpt);
            gsPlay  : if oldField = 0 then
                       begin
                        if center then setmarker(1+col+row*HSize);
                       end
                       else addPlayNumber(oldfield,oldOpt);
           end;//case
  mbRight : case gameStatus of
             gsGrid  : paintmode := pmErase;
             gsDigit : ;
             gsPlay  : if oldfield <> 0 then
                        begin
                         with field[oldfield] do
                           options := options and ($3e xor (1 shl oldOpt));
                         paintfield(oldField);
                         if warningbox.Checked then checkoptions;
                       end;
            end;//case
 end;//case
 oldField := 0;
 oldOpt := 0;
end;

procedure TForm1.PaintBox1MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
var newField, newOpt : byte;
    fx,fy : smallInt;
    r : Trect;
begin
 if paintMode <> pmNone then begin
                              setEdge(x,y);
                              exit;
                             end;
 if checkbox1.checked then
  if (gameStatus = gsDigit) or (gameStatus=gsPlay) then
   begin
    XY2Optionfield(x,y,newfield,newOpt);
    if (newfield <> oldfield) or (oldOpt <> newOpt) then
     begin
      if oldfield > 0 then paintfield(oldfield);    //erase old markers
      oldfield := newfield;
      oldOpt := newOpt;
      if (oldfield <> 0) and (newOpt <> 0) then
       begin
        fieldNr2XY(fx,fy,oldfield);
        with paintbox1.Canvas do
         begin
          brush.Style := bsClear;
          pen.color := $ff0000;
          pen.Width := 1;
          r := OpRect[oldOpt];       
          r.left := r.left + fx;
          r.right := r.right + fx;
          r.top := r.top + fy;
          r.bottom := r.bottom + fy;
          rectangle(r);
         end;
       end;
     end;
   end;
end;

procedure TForm1.PaintBox1MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
 paintMode := pmNone;
end;

// keyboard events

procedure TForm1.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var maxmarker,n: byte;
begin
 activecontrol := nil;
 hintActive := 0;
 maxmarker := Hsize*Vsize;
 n := marker;
 if n > 0 then
  begin
   case key of
    VK_LEFT,
    VK_BACK   : if n > 1 then dec(n);
    VK_RIGHT,
    VK_SPACE  : if n < maxmarker then inc(n);
    VK_UP     : if n > Hsize then dec(n,HSize);
    VK_DOWN   : if n <= maxmarker-Hsize then inc(n,HSize);
    VK_DELETE : processDelete;
   end;//case
   setmarker(n);
 end;//if n > 0
end;

procedure TForm1.FormKeyPress(Sender: TObject; var Key: Char);
begin
 if key in ['1'..'5'] then
  if (marker > 0) then
   begin
    hintActive := 0;
    case gameStatus of
     gsDigit : addOrgNumber(marker,strtoint(key));
     gsPlay  : addPlayNumber(marker,strtoint(key));
    end;//case
  end;//if
end;

// button & timer events

procedure TForm1.Timer1Timer(Sender: TObject);
//for quick paintbox1 resizing
begin
 paintFormEdges(form1.canvas.brush.Color);
 case timercode of
  1 : if HSize < 15 then inc(HSize);
  2 : if HSize > 5 then dec(HSize);
  3 : if VSize < 10 then inc(VSize);
  4 : if VSize > 5 then dec(Vsize);
 end;//case
 showdimensions;
 initGridEdges;
 setPaintbox1Dimensions;
end;

procedure TForm1.hplusBtnMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
 postmessage('');
 if (gameStatus = gsGrid) then
  begin
   timercode := TSpeedbutton(sender).Tag;
   timer1timer(self);
   timer1.Enabled := true;
  end;
end;

procedure TForm1.hplusBtnMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
 timer1.Enabled := false;
end;

procedure TForm1.gridBtnClick(Sender: TObject);
begin
 gameControl(gmGridBtn);
end;

procedure TForm1.digitBtnClick(Sender: TObject);
begin
 gamecontrol(gmDigitBtn);
end;

procedure TForm1.playBtnClick(Sender: TObject);
begin
 gameControl(gmPlayBtn);
end;

procedure TForm1.loadBtnClick(Sender: TObject);
var code : byte;
begin
 activecontrol := nil;
 loadgame(code);
 case code of
  0 : begin
       paintFormEdges(form1.canvas.brush.Color);
       setpaintbox1Dimensions;
       showdimensions;
       case gamestatus of
        gsDigit  : begin
                    registerGroups;
                   end;
        gsPlay,
        gsEnd    : begin
                    registerGroups;
                   end;
       end; //case
      end;
  1 : postmessage('file not found');
  2 : postmessage('wrong filename');
  3 : postmessage('read error');
  4 : postmessage('wrong file ID');
 end;
end;

procedure TForm1.storeBtnClick(Sender: TObject);
var code : byte;
begin
 activecontrol := nil;
 savegame(code);
 case code of
  0 : postmessage('game saved');
  1 : postmessage('game not saved');
  2 : postmessage('write error');
 end;
end;

procedure TForm1.helpBtnClick(Sender: TObject);
begin
 activecontrol := nil;
 ShellExecute(0,'open','http://www.davdata.nl/math/tect-help.html', nil, nil, SW_SHOWNORMAL);
end;

procedure TForm1.clearBtnClick(Sender: TObject);
begin
 activecontrol := nil;
 gameControl(gmClearBtn);
end;

procedure TForm1.hintBtnClick(Sender: TObject);
var n : byte;
    hint : boolean;
    s : string;
begin
 activecontrol := nil;
 if gamestatus <> gsPlay then exit;
//
 if hintactive > 0 then procActiveHints;
//
 if checkOptions = false then exit;
//
 hint := procHint1(h1);
 if hint then
  begin
   n := getBit1(field[h1.fld].options);
   s := 'single option '+inttostr(n);
   postmessage(s);
   setmarker(h1.fld);
   hintactive := 1;
   if hintcount < 250 then inc(hintcount);
  end;
 if hint then exit;
//
 hint := procHint2(h2);
 if hint then
  begin
   s := 'single field for option '+inttostr(h2.nr);
   msglabel.caption := s;
   setmarker(h2.fld);
   hintActive := 2;
   if hintcount < 250 then inc(hintcount);
  end;
 if hint then exit;
//
 if form1.CheckBox1.Checked = false then
  begin
   form1.msglabel.Caption := 'select OPTIONS for more help';
   exit;
  end; 
 hint := procHint3(h3);
 if hint then
  begin
   hintactive := 3;
   msglabel.Caption := 'press HINT to remove red option(s)';
   paintoptionmarks(h3);
   if hintcount < 250 then inc(hintcount);
  end;
 if hint then exit;
//
 hint := procHint4(h4);
 if hint then
  begin
   paintoptionmarks(h4);
   hintactive := 4;
   postmessage('press HINT to remove redundant options');
   if hintcount < 250 then inc(hintcount);
  end;
 if hint then exit;
//
 if checkEnd then setgamestatus(gsEnd)
  else postmessage('no hints found');
end;

procedure TForm1.optresetBtnClick(Sender: TObject);
begin
 activecontrol := nil;
 if (gameStatus = gsPlay) then
  begin
   if errormark then clearErrorFields;
   recalcFieldOptions;
   repaintfields;
  end;
end;

procedure TForm1.CheckBox1Click(Sender: TObject);
begin
 activecontrol := nil;
 if gamestatus <> gsGrid then repaintfields;
end;

procedure TForm1.warningboxClick(Sender: TObject);
begin
 activecontrol := nil;
end;

//form1 paints

procedure TForm1.PaintBox1Paint(Sender: TObject);
var i : byte;
begin
 paintformedges($000000);//on form1.canvas
 paintgameGrid;
 for i := 1 to HSize*Vsize do
  begin
   paintFieldEdges(i);
   paintfield(i);
  end;
 if marker <> 0 then paintmarker(marker,true);
end;

//-- create --

procedure TForm1.FormCreate(Sender: TObject);
begin
 setgameStatus(gsGrid);
 initGridEdges;
 clearGame;
 activecontrol := nil;
end;

end.
